/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.batch.functionsample.sample003;


import java.util.ArrayList;
import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import jp.terasoluna.fw.batch.openapi.BLogic;
import jp.terasoluna.fw.batch.openapi.BLogicResult;
import jp.terasoluna.fw.batch.openapi.JobContext;
import jp.terasoluna.fw.batch.openapi.ReturnCode;
import jp.terasoluna.fw.dao.QueryDAO;
import jp.terasoluna.fw.file.dao.FileLineWriter;
import jp.terasoluna.fw.file.dao.FileUpdateDAO;
import jp.terasoluna.batch.functionsample.common.NyusyukkinData;
import jp.terasoluna.batch.functionsample.common.SitenData;

/**
 * ビジネスロジッククラス。<br>
 * ヘッダ-明細-トレイラを出力する。
 * 
 */
public class Sample003BLogic implements BLogic<SitenData, JobContext> {

    /**
     * ログクラス。
     */
    private static final Log log = LogFactory.getLog(Sample003BLogic.class);

    /**
     * DAOクラス。
     * Springによりインスタンス生成され設定される。
     */
    private QueryDAO queryDAO;
    
    /**
     * DAOクラス。
     * Springによりインスタンス生成され設定される。
     */
    private FileUpdateDAO updateDAO;
    
    /**
     * ファイル出力ディレクトリ。
     * Springによりインスタンス生成され設定される。
     */
    private String basePath;
    
    /**
     * 処理を起動する。
     */
    public BLogicResult execute(SitenData siten, JobContext arg1) {
    
    if(log.isDebugEnabled()){
        log.debug(siten.getSitenmei() + " start.");
    }

    // ファイル出力用行ライタの取得
    FileLineWriter<NyusyukkinData> fileLineWriter 
        = updateDAO.execute(basePath + siten.getSitenmei() + ".csv", NyusyukkinData.class);

    try{
        //ヘッダ部の出力
        List<String> header = new ArrayList<String>();
        header.add("支店名：" + siten.getSitenmei());
        header.add("住所：" + siten.getSitenjusyo());
        header.add("電話番号：" + siten.getSitentel());
        fileLineWriter.printHeaderLine(header);
        	
        //データ部の出力
        NyusyukkinData[] nyusyukkinArray = 	
        queryDAO.executeForObjectArray("SAMPLE003.getNyusyukkinDataBySiten", siten.getSitencd(), NyusyukkinData.class);
        
        long nyukinKingaku = 0L;
        long syukkinKingaku = 0L;
        for(NyusyukkinData nyusyukkin : nyusyukkinArray){

        	fileLineWriter.printDataLine(nyusyukkin);
        	
        	if(nyusyukkin.getNyusyukkincd() == 0){
        	    nyukinKingaku += nyusyukkin.getKingaku();
        	}else{
        	    syukkinKingaku += nyusyukkin.getKingaku();
        	}
        }
        
        //トレイラ部の出力
        List<String> trailer = new ArrayList<String>();
        trailer.add("入金合計：" + nyukinKingaku);
        trailer.add("出金合計：" + syukkinKingaku);
        fileLineWriter.printTrailerLine(trailer);
    
    }finally{
        fileLineWriter.closeFile();
    }

    if(log.isDebugEnabled()){
        log.debug(siten.getSitenmei() + " end.");
    }
    
    
    return new BLogicResult(ReturnCode.NORMAL_CONTINUE);
    }

    /**
     * UpdateDAOを設定する。
     * @param updateDAO 設定するUpdateDAO
     */
    public void setUpdateDAO(FileUpdateDAO updateDAO) {
        this.updateDAO = updateDAO;
    }
    
    /**
     * QueryDAOを設定する。
     * @param queryDAO 設定するQueryDAO
     */
    public void setQueryDAO(QueryDAO queryDAO) {
        this.queryDAO = queryDAO;
    }
    
    /**
     * ファイル出力ディレクトリを設定する。
     * @param basePath 設定するファイル出力ディレクトリのパス
     */
    public void setBasePath(String basePath){
    this.basePath = basePath;
    }
}
